import jp.jig.jiglet.*;

/*
Download as TAR jiglet
    Copyright (C) 2007 jiglet.info

̃vOMITCZX̂ƂŌJĂ܂B
This program is provided by the MIT License.

*******************************************************************************
The MIT License


Copyright (c) 2007 jiglet.info

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*******************************************************************************
*/

public class dl2tar extends Jiglet {
	String targetURL, saveName;

	int dlImageID = 0;
	final int imageWidth = 160, imageHeight = 40;
	Image[] downloading;
	Image waiting;
	Image[] dumpDigit;
	Image tempExpanded;
	byte[] rawExpanded;

	boolean isDownloadingMode = true;
	boolean largeSizeScreen = false;

	String[] dataNames;
	String[] dataInfos;
	String[] menuString;
	boolean isMenu;
	int menuSelID;

	int[] dataStarts, dataSizes;
	final int loadLimit = 32767;
	int loadedNums = 0;
	int nextLoadPos = 0, maxLoadPos = 0;
	int scrollStart = 0, nowSelected = 0, maxVisible = 0, titleScrolling = 0, titleWidth = 0;
	int imageScrollX = 0, imageScrollY = 0;

	int waitMax = 0, waitDone = 0;

	byte[][] dumpList;
	String[] dumpSJIS;

	public void paint(boolean allDrawFlag) {
		setColor(getSystemColor(SYSTEM_COLOR_MENU_BG));
		fillRect(0, 0, DW, DH);
		setFont(FONT_SMALL);
		maxVisible = DH / getFontHeight() / 2 - 1;

		if (tempExpanded != null) {
			/*
				摜WJ\[h
			*/
			drawImage(tempExpanded, imageScrollX, imageScrollY);

			if (DH < tempExpanded.getHeight()) {
				setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BG));
				fillRect(DW - 4, 0, 4, DH);
				setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BAR));
				fillRect(DW - 4, (DH * -imageScrollY / tempExpanded.getHeight()), 4, (DH * DH / tempExpanded.getHeight() + 1));
			}
			if (DW < tempExpanded.getWidth()) {
				setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BG));
				fillRect(0, DH - 4, DW, 4);
				setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BAR));
				fillRect((DW * -imageScrollX / tempExpanded.getWidth()), DH - 4, (DW * DW / tempExpanded.getWidth() + 1), 4);
			}
		} else if (dumpList != null) {
			/*
				t@Cedump[h
			*/
			draw3DButton(0, 0, DW, getFontHeight());
			draw3DButton(0, DH - getFontHeight(), DW, getFontHeight());
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT1));
			drawString("dump: " + dataNames[nowSelected], 4, getFontHeight());
			drawString("L[ŉ摜̓WJ݂܂B", 4, DH);

			setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
			for (int i = 0; i < dumpList.length; i++) {
				drawDumpBinaries(dumpList[i], dumpDigit[0].getWidth() / 2, (i + 1) * getFontHeight() + (getFontHeight() - dumpDigit[0].getHeight()) / 2 + 3);
				if ((dumpSJIS != null) && (dumpSJIS[i] != null)) {
					drawString(dumpSJIS[i], dumpDigit[0].getWidth() * 33, (i + 2) * getFontHeight() + 2);
				}
			}
		} else if (isDownloadingMode) {
			/*
				Now Downloading...C[W`
			*/
			if ((downloading != null) && (downloading[dlImageID] != null)) {
				drawImage(downloading[dlImageID], DW - imageWidth, DH - imageHeight);
				if (++dlImageID >= downloading.length) {
					dlImageID = 0;
				}
			}
		} else {
			if (loadedNums > 0) {
				/*
					f[^1ł[hĂꍇ͈ꗗ`悷
				*/
				draw3DButton(0, 0, DW, getFontHeight());
				draw3DButton(0, DH - getFontHeight(), DW, getFontHeight());
				setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT1));
				drawString("DaT - " + loadedNums + " files loaded." + (waitMax > 0 ? " (" + (100L * waitDone / waitMax) + "%)" : ""), 4, getFontHeight());
				drawString("L[Ő擪256oCg_v܂B", 4, DH);
				for (int i = 0, drawX = 0; i < maxVisible; i++) {
					if (i + scrollStart >= loadedNums) {
						break;
					}
					if (i + scrollStart == nowSelected) {
						/*
							IĂ
						*/
						setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
						fillRect(0, (i * 2 + 1) * getFontHeight(), DW, getFontHeight() * 2);
						setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
						if (titleWidth > DW) {
							drawX = titleScrolling;
							if ((titleScrolling -= 2) < -titleWidth) {
								titleScrolling = DW;
							}
						} else {
							drawX = 0;
						}
					} else {
						setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
						drawX = 0;
					}
					if (dataNames[i + scrollStart] != null) {
						drawString(dataNames[i + scrollStart], drawX, (i * 2 + 2) * getFontHeight());
					}
					if (dataInfos[i + scrollStart] != null) {
						drawString(dataInfos[i + scrollStart], 0, (i * 2 + 3) * getFontHeight());
					}
				}
				if (loadedNums > maxVisible) {
					/*
						XN[o[`
					*/
					int DH2 = DH - getFontHeight() * 2;
					setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BG));
					fillRect(DW - 4, getFontHeight(), 4, DH2);
					setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BAR));
					fillRect(DW - 4, (DH2 * scrollStart / loadedNums) + getFontHeight(), 4, (DH2 * maxVisible / loadedNums + 1));
				}
			} else {
				/*
					f[^1[hĂȂꍇ̑
				*/
				setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
				drawString("wait...", (DW - stringWidth("wait...")) / 2, (DH - getFontHeight()) / 2 + getFontHeight());
			}
		}

		if (waitMax > 0) {
			int barWidth;
			if (waiting != null) {
				/*
					Now Loadingȍv`
				*/
				drawImage(waiting, DW - waiting.getWidth(), DH - waiting.getHeight() - 8);
				barWidth = waiting.getWidth();
			} else {
				barWidth = imageWidth;
			}
			setColor(getSystemColor(SYSTEM_COLOR_STATUS_BG1));
			fillRect(DW - barWidth, DH - 8, barWidth, 8);
			setColor(getSystemColor(SYSTEM_COLOR_STATUS_BG2));
			fillRect(DW - barWidth, DH - 8, (barWidth * waitDone / waitMax), 8);
		}

		if (isMenu) {
			int menuW = 0, menuH = (menuString.length * getFontHeight());
			for (int i = 0; i < menuString.length; i++) {
				if (stringWidth(menuString[i]) > menuW) menuW = stringWidth(menuString[i]);
			}
			draw3DButton((DW - menuW - 4) / 2, (DH - menuH - 4) / 2, menuW + 4, menuH + 4);
			for (int i = 0; i < menuString.length; i++) {
				if (i == menuSelID) {
					setColor(getSystemColor(SYSTEM_COLOR_BUTTON_CURSOR));
					fillRect((DW - menuW) / 2, (DH - menuH) / 2 + i * getFontHeight(), menuW, getFontHeight());
					setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT2));
				} else {
					setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT1));
				}
				drawString(menuString[i], (DW - menuW) / 2, (DH - menuH) / 2 + (i + 1) * getFontHeight());
			}
		}
	}
	private final void drawDumpBinaries(byte[] in, int x, int y) {
		if (dumpDigit == null) {
			println("dumpDigit is null!");
			return;
		}
		for (int i = 0; i < in.length; i++) {
			drawImage(dumpDigit[(in[i] & 0xf0) >>> 4], x, y);
			drawImage(dumpDigit[in[i] & 0x0f], x + dumpDigit[0].getWidth() - 1, y);
			x += dumpDigit[0].getWidth() * 2;
		}
	}
	
	public void main() {
		/*
			N[h`FbNB
				getLaunchType() LAUNCHED_AS_TASK(=1)̂ƂŁAURLnĂuURL(ryv
				getLaunchType() LAUNCHED_AS_TOOL(=2)̂ƂAURLnĂȂʏN
		*/
		largeSizeScreen = (DW >= 480);
		{
			byte[] byteParam = null;
			if ((getKey() & EVENT_LAUNCHED) == EVENT_LAUNCHED) {
				byteParam = getLaunchParameter();
			}
			int launchType = getLaunchType();
			String param = null;
			boolean isURL = false;
			if (byteParam != null) {
				param = new String(byteParam);
				isURL = (param.startsWith("http://") || param.startsWith("https://"));
			}
			if ((launchType == LAUNCHED_AS_TASK) && isURL) {
				/*
					URLjigletɓn ŋNꂽB(܂_E[hׂ)
				*/
				downloadDatas(param);
			} else {
				/*
					̑̏A܂蕁ʂɋNꂽB
				*/
				isDownloadingMode = false;
				viewList();
			}
		}
	}

	private final void viewList() {
		String[] mnuImage = new String[] {
			"摜̓WJ݂",
			"f[^tH_֕ۑ",
			"ԊOM",
			"ꗗ֖߂",
			"LZ",
		};

		dataNames = new String[loadLimit];
		dataInfos = new String[loadLimit];
		dataSizes = new int[loadLimit];
		dataStarts = new int[loadLimit];
		loadedNums = 0;
		nextLoadPos = 0;
		waitMax = maxLoadPos = getLengthSP();
		scrollStart = 0;
		nowSelected = 0;
		waiting = getImage("wait.gif");

		dumpDigit = new Image[16];
		for (int i = 0; i < 16; i++) {
			dumpDigit[i] = getImage((largeSizeScreen ? "l" : "d") + i + ".gif");
		}

		if (maxLoadPos == 0) {
			showDialog("1ۑĂ܂B", DIALOG_TYPE_OK);
			terminate();
		}

		for (;;) {
			if ((nextLoadPos < maxLoadPos) && (loadedNums < loadLimit)) {
				loadNextRecord();
				if (! (((waitDone = nextLoadPos) < maxLoadPos) && (loadedNums < loadLimit))) {
					waitMax = 0;
					setSoftLabel("S폜");
				}
			} else {
				sleep(50);
			}
			int key = getKey();
			if (tempExpanded != null) {
				/*
					摜vr[Ă
				*/
				if ((key == KEY_SOFT) || (key == KEY_IAPP)) {
					/*
						\tgL[Ń_vXgɖ߂
					*/
					tempExpanded = null;
				}
				/*
					L[ŉ摜̕\ʒuړ
				*/
				if (key == KEY_LEFT) {
					if ((imageScrollX += 16) > 0) {
						imageScrollX = 0;
					}
				}
				if (key == KEY_RIGHT) {
					if ((imageScrollX -= 16) < (DW - 4 - tempExpanded.getWidth())) {
						imageScrollX = DW - 4 - tempExpanded.getWidth();
					}
				}
				if (key == KEY_UP) {
					if ((imageScrollY += 16) > 0) {
						imageScrollY = 0;
					}
				}
				if (key == KEY_DOWN) {
					if ((imageScrollY -= 16) < (DH - 4 - tempExpanded.getHeight())) {
						imageScrollY = DH - 4 - tempExpanded.getHeight();
					}
				}

				if (key == KEY_SELECT) {
					/*
						L[ŉ摜[ɕۑ
					*/
					saveImageToPhone(rawExpanded);
				}
			} else if (dumpList != null) {
				/*
					_vXg\
				*/
				if ((key == KEY_SOFT) || (key == KEY_IAPP)) {
					/*
						\tgL[NAL[ňꗗɖ߂
					*/
					dumpList = null;
					setSoftLabel("S폜");
				}
				if (key == KEY_SELECT) {
					/*
						L[ŏI
					*/
					switch (showMenu(mnuImage)) {
						case 0: {
							/*
								摜WJ
							*/
							imageScrollX = 0;
							imageScrollY = 0;
							rawExpanded = readSP(dataStarts[nowSelected], dataSizes[nowSelected]);
							println("load: " + rawExpanded.length + "bytes");
							if (rawExpanded == null) {
								showDialog("ǂݍ݂Ɏs܂B\nf[^ۑĂȂAs̉\܂B", DIALOG_TYPE_OK);
							} else {
								tempExpanded = getImage(rawExpanded);
								if (tempExpanded == null) {
									println("this image is broken!");
									if (showDialog("jigletœǂݍ߂^Cv̉摜ł͂Ȃ悤łB\nf[^tH_ւ̕ۑ݂܂H", DIALOG_TYPE_YES_NO) == DIALOG_YES) {
										if (! saveImageToPhone(rawExpanded)) {
											showDialog("f[^tH_֕ۑł܂B", DIALOG_TYPE_OK);
										}
									}
								} else {
									println("loading...done");
								}
							}
							break;
						}
						case 1: {
							/*
								f[^tH_֕ۑ
							*/
							if (! saveImageToPhone(rawExpanded)) {
								showDialog("f[^tH_֕ۑł܂B", DIALOG_TYPE_OK);
							}
							break;
						}
						case 2: {
							/*
								ԊOM
							*/
							if (dataSizes[nowSelected] > 100 * 1024) {
								showDialog("100KBzĂ邽߁AԊOMł܂B", DIALOG_TYPE_OK);
								break;
							}

							int lastSlash = dataNames[nowSelected].lastIndexOf('/');
							byte[] raw = readSP(dataStarts[nowSelected], dataSizes[nowSelected]), front = new byte[4];
							String dataType, sendName;

							if (lastSlash >= 0) {
								sendName = dataNames[nowSelected].substring(lastSlash + 1);
							} else {
								sendName = dataNames[nowSelected];
							}
							if (raw.length > 4) {
								arraycopy(raw, 0, front, 0, 4);
								dataType = new String(front);
								if (dataType.startsWith("GIF")) {
									dataType = "Content-type: image/gif";
								} else if (dataType.startsWith("PNG")) {
									dataType = "Content-type: image/png";
								} else {
									arraycopy(raw, 6, front, 0, 4);
									dataType = new String(front);
									if (dataType.startsWith("JFIF")) {
										dataType = "Content-type: image/jpeg";
									} else {
										dataType = "Content-type: application/octet-stream";
									}
								}
							} else {
								dataType = "Content-type: application/octet-stream";
							}
						/*
							showDialog("Name: " + sendName + "\nType: " + dataType + "\nLength: " + raw.length, DIALOG_TYPE_OK);
						*/
							if (! sendOBEX(raw, sendName, dataType)) {
								showDialog("̓db@jigletɂԊOʐMɑΉĂ܂B", DIALOG_TYPE_OK);
							}
							break;
						}
						case 3: {
							/*
								ꗗ֖߂
							*/
							dumpList = null;
							setSoftLabel("S폜");
							break;
						}
					}

				}
			} else {
				/*
					ꗗ\
				*/
				if ((key == KEY_UP) && (nowSelected > 0)) {
					if (--nowSelected <= scrollStart) {
						if ((scrollStart = nowSelected - 1) < 0) {
							scrollStart = 0;
						}
					}
					titleWidth = stringWidth(dataNames[nowSelected]);
					titleScrolling = 0;
				}
				if ((key == KEY_DOWN) && (nowSelected < loadedNums - 1)) {
					if (++nowSelected >= scrollStart + maxVisible - 1) {
						if ((scrollStart = nowSelected - maxVisible + 2) > loadedNums - maxVisible) {
							scrollStart = loadedNums - maxVisible;
						}
					}
					titleWidth = stringWidth(dataNames[nowSelected]);
					titleScrolling = 0;
				}
				if (key == KEY_SOFT) {
					if (! ((nextLoadPos < maxLoadPos) && (loadedNums < loadLimit))) {
						if (showDialog("XNb`pbh̃f[^Sč폜܂B\n낵łH", DIALOG_TYPE_NO_YES) == DIALOG_YES) {
							setLengthSP(0);
							showDialog("SẴf[^폜܂B", DIALOG_TYPE_OK);
							terminate();
						}
					}
				}
				if (key == KEY_SELECT) {
					dumpList = new byte[16][16];
					dumpSJIS = new String[dumpList.length];

					byte[] head = readSP(dataStarts[nowSelected], 256);
					for (int i = 0; i < 16; i++) {
						arraycopy(head, i * 16, dumpList[i], 0, 16);
						dumpSJIS[i] = new String(dumpList[i]);
					}
					setSoftLabel("߂");
				}
				if (key == KEY_IAPP) {
					terminate();
				}
			}
			repaint();
		}
	}

	private final void loadNextRecord() {
		byte[] head = readSP(nextLoadPos, 512);

		if (head[0] == 0) {
			nextLoadPos += 512;
			return;
		}

		dataStarts[loadedNums] = nextLoadPos + 512;

		byte[] bytName = new byte[101];
		arraycopy(head, 0, bytName, 0, 100);
		String strName = new String(bytName);
		dataNames[loadedNums] = strName.substring(0, strName.indexOf(0));

		byte[] bytInt = new byte[12];
		arraycopy(head, 136, bytInt, 0, 12);
		setTime(convOctBytesToLong(bytInt) * 1000);
		dataInfos[loadedNums] = "  -- " + makeDateTime();

		arraycopy(head, 124, bytInt, 0, 12);
		int fsize = (int)convOctBytesToLong(bytInt);
		dataInfos[loadedNums] = dataInfos[loadedNums] + " " + addPrefixOfFileSize(fsize);
		dataSizes[loadedNums] = fsize;

		loadedNums++;
		nextLoadPos += 512 + 512 * ((fsize + 511) / 512);
	}

	private final String makeDateTime() {
		String ret = "" + getTime(CALENDAR_YEAR) + "/";
		if (getTime(CALENDAR_MONTH) + 1 < 10) {
			ret = ret + "0";
		}
		ret = ret + (getTime(CALENDAR_MONTH) + 1) + "/";

		if (getTime(CALENDAR_DATE) < 10) {
			ret = ret + "0";
		}
		ret = ret + getTime(CALENDAR_DATE) + " ";

		if (getTime(CALENDAR_HOUR_OF_DAY) < 10) {
			ret = ret + "0";
		}
		ret = ret + getTime(CALENDAR_HOUR_OF_DAY) + ":";

		if (getTime(CALENDAR_MINUTE) < 10) {
			ret = ret + "0";
		}
		ret = ret + getTime(CALENDAR_MINUTE) + ":";

		if (getTime(CALENDAR_SECOND) < 10) {
			ret = ret + "0";
		}
		ret = ret + getTime(CALENDAR_SECOND);

		return(ret);
	}

	private final String addPrefixOfFileSize(long fsize) {
		if (fsize > 1024 * 1024 * 1024) {
			return("" + (fsize / 1024 / 1024 / 1024) + "." + (fsize * 100 / 1024 / 1024 / 1024 % 100) + "GiB");
		} else if (fsize > 1024 * 1024) {
			return("" + (fsize / 1024 / 1024) + "." + (fsize * 100 / 1024 / 1024 % 100) + "MiB");
		} else if (fsize > 1024) {
			return("" + (fsize / 1024) + "." + (fsize * 100 / 1024 % 100) + "KiB");
		} else {
			return("" + fsize + "Byte");
		}
	}

	private final void downloadDatas(String targetURL) {
		/*
			_E[h[h
		*/
		isDownloadingMode = true;

		/*
			󂫗eʃ`FbNB1MBȉȂNȂB
		*/
		if (getFreeSizeSP() < 1024 * 1024) {
			showDialog("SDJ[hɕۑĂNĂB\nSDJ[hɕۑĂɂւ炸̃bZ[Woꍇ́ASDJ[h̋󂫗eʂɒ[ɕsĂ\܂B", DIALOG_TYPE_OK);
			terminate();
		}

		if (targetURL.startsWith("http://")) {
			saveName = targetURL.substring(7);
		} else {
			saveName = targetURL.substring(8);
		}

		saveName = renameURLtoSafe(saveName);

		while ((saveName.length() > 100) && (saveName.indexOf("/") >= 0)) {
			saveName = saveName.substring(saveName.indexOf("/") + 1);
		}

		if (showDialog(targetURL + "_E[hA" + saveName + "Ƃĕۑ܂B", DIALOG_TYPE_YES_NO) == DIALOG_NO) {
			terminate();
		}

		downloading = new Image[12];
		for (int i = 0; i < 12; i++) {
			downloading[i] = getImage(i + ".gif");
		}
		setSoftLabel("");

		int DLID = accessHTTP(getSourceURL() + "jump.php?a=" + encodeBase64(targetURL.getBytes()), null);
		if (DLID < 0) {
			showDialog("_E[hURLsłBĂoOB\n" + targetURL, DIALOG_TYPE_OK);
			terminate();
		}
		for (int key;;) {
			key = getKey();
			if ((key > 0) && ((key & EVENT_HTTP) == EVENT_HTTP)) {
				break;
			}
			sleep(100);
			repaint();
		}

		byte[] downloaded = getHTTP(DLID);
		if (downloaded == null) {
			showDialog("ʐMɎsA͒f܂B", DIALOG_TYPE_OK);
			terminate();
		}

		for (;;) {
			String warn = "";
			if (downloaded.length > 153592) {
				warn = " 150KiBzf[^łB150KiBȍ~͐ł͂Ȃ\܂B\n";
			}
			if (showDialog(targetURL + "̃_E[hɐA" + downloaded.length + "oCg̃f[^_E[h܂B\n" +
				warn + "̃f[^ۑ܂H", DIALOG_TYPE_YES_NO) == DIALOG_YES) {
				break;
			}
			if (showDialog("_E[hf[^j܂B낵łH", DIALOG_TYPE_NO_YES) == DIALOG_YES) {
				downloaded = null;
				gc();
				showDialog("f[^j܂B", DIALOG_TYPE_OK);
				terminate();
			}
		}

		if (addToTarball(saveName, downloaded, "")) {
			showDialog("ۑɐ܂B\nSDJ[h̕ۑ̈ɋL^ꂽTARɂɁA" +
				saveName + "Ƃt@CŒǉ܂B", DIALOG_TYPE_OK);
		} else {
			showDialog("ۑɎs܂B\n󂫗eʂȂAXNb`pbhĂ܂B", DIALOG_TYPE_OK);
		}
		terminate();
	}

	private final boolean addToTarball(String name, byte[] data, String prefix) {
		/*
			TarballɃf[^ǉ
		*/
		int addPoint = getLengthSP();
		long checksum = 0;

		if (addPoint > 1024) {
			addPoint -= 1024;
		}

		if (! setLengthSP(addPoint + 512 * ((data.length + 511) / 512) + 512 + 1024)) {
			/*
				XNb`pbh̒ςȂ΃G[
			*/
			return(false);
		}
		/* t@CL^ */
		{
			byte[] namesBytes = new byte[101];
			byte[] origBytes = name.getBytes();
			if (origBytes.length < 100) {
				arraycopy(origBytes, 0, namesBytes, 0, origBytes.length);
			} else {
				arraycopy(origBytes, 0, namesBytes, 0, 100);
			}
			String tmpName = new String(namesBytes);
			namesBytes = (tmpName.substring(0, tmpName.length() - 1)).getBytes();
			writeSP(addPoint + 0, namesBytes);
			checksum += makeChecksumForTar(namesBytes);
		}
		/* p[~bV⃆[U[L^(悤ɂ邯) */
		{
			byte[] tmpPerms = ("   777 \0" + "     0 \0" + "     0 \0").getBytes();
			writeSP(addPoint + 100, tmpPerms);
			checksum += makeChecksumForTar(tmpPerms);
		}


		/* t@CTCYL^ */
		{
			byte[] oct = convLongToL12OctBytes(data.length);
			writeSP(addPoint + 124, oct);
			checksum += makeChecksumForTar(oct);
		}

		/* XV݂ɃZbg */
		{
			byte[] oct = convLongToL12OctBytes(currentTime() / 1000);
			writeSP(addPoint + 136, oct);
			checksum += makeChecksumForTar(oct);
		}

		/* `FbNT */
		{
			byte[] writeSum = new byte[9];
			/* Ō̃^CvtOԂƃ`FbNT󂠂ԂZ */
			checksum += 48 + 0x100;
			for (int i = 6; i >= 0; i--) {
				/* ASCIIR[hɂ'0'̃R[hɑĐ'' */
				writeSum[i] = (byte)(48 + (checksum & 7));
				checksum = checksum >>> 3;
			}
			writeSum[8] = 48;
			writeSP(addPoint + 148, writeSum);
//			checksum += makeChecksumForTar(oct);
		}

		{
			byte[] writeBuffer = new byte[10 * 1024];
			waitMax = data.length;
			for (int i = 0; i < data.length; i += writeBuffer.length) {
				/*
					10KBɕċL^
				*/
				if (writeBuffer.length > (data.length - i)) {
					/*
						Ŋ̃ZNVɍ킹ăobt@k߂
					*/
					writeBuffer = new byte[data.length - i];
				}
				arraycopy(data, i, writeBuffer, 0, writeBuffer.length);
				writeSP(addPoint + 512 + i, writeBuffer);
				waitDone = i;
				repaint();
			}
			waitMax = 0;
		}
		return(true);
	}
	private final byte[] convLongToL12OctBytes(long in) {
		byte[] ret = new byte[12];
		for (int i = 10; i >= 0; i--) {
			/* ASCIIR[hɂ'0'̃R[hɑĐ'' */
			ret[i] = (byte)(48 + (in & 7));
			in = in >>> 3;
		}
		return(ret);
	}
	private final long convOctBytesToLong(byte[] in) {
		long ret = 0;
		for (int i = 0; i < in.length; i++) {
			/* ASCIIR[hɂ'0'̃R[hĐ'l' */
			if ((in[i] >= 48) && (in[i] <= 57)) {
				ret = ret << 3;
				ret += in[i] - 48;
			}
		}
		return(ret);
	}
	private final long makeChecksumForTar(byte[] in) {
		long cs = 0;
		for (int i = 0; i < in.length; i++) {
			cs += (in[i] < 0 ? in[i] + 256 : in[i]);
		}
		return(cs);
	}

	private final String renameURLtoSafe(String in) {
		int st;
		while ((st = in.indexOf(":")) >= 0) {
			in = in.substring(0, st) + "F" + in.substring(st + 1);
		}
		while ((st = in.indexOf("\\")) >= 0) {
			in = in.substring(0, st) + "" + in.substring(st + 1);
		}
		while ((st = in.indexOf("?")) >= 0) {
			in = in.substring(0, st) + "H" + in.substring(st + 1);
		}
		while ((st = in.indexOf("\"")) >= 0) {
			in = in.substring(0, st) + "h" + in.substring(st + 1);
		}
		while ((st = in.indexOf("<")) >= 0) {
			in = in.substring(0, st) + "" + in.substring(st + 1);
		}
		while ((st = in.indexOf(">")) >= 0) {
			in = in.substring(0, st) + "" + in.substring(st + 1);
		}
		while ((st = in.indexOf("|")) >= 0) {
			in = in.substring(0, st) + "b" + in.substring(st + 1);
		}
		return(in);
	}

	private int showMenu(String[] menuContents) {
		menuString = menuContents;
		isMenu = true;
		menuSelID = 0;

		int key, ret = 0;
		while (true) {
			repaint();
			key = getKey();
			if (key == KEY_UP) {
				if (--menuSelID < 0) menuSelID = menuString.length - 1;
				continue;
			}
			if (key == KEY_DOWN) {
				if (++menuSelID >= menuString.length) menuSelID = 0;
				continue;
			}
			if ((key == KEY_IAPP) | (key == KEY_SOFT)) {
				ret = -1;
				break;
			}
			if (key == KEY_SELECT) {
				ret = menuSelID;
				break;
			}
		}

		isMenu = false;
		menuString = null;
		return(ret);
	}
}
